#define VK_SPACE       0x0020
#define VK_ENTER       0x000D
#define VK_RETURN      0x0A0D
#define VK_ESCAPE      0x001B
#define VK_BKSPACE     0x0008
#define VK_TAB         0x0009
#define VK_SHIFT_TAB   0x0F00
#define VK_BELL        0x0007
#define VK_INSERT      0x5200
#define VK_DELETE      0x5300
#define VK_HOME        0x4700
#define VK_END         0x4F00
#define VK_PGUP        0x4900
#define VK_PGDN        0x5100
#define VK_UP          0x4800
#define VK_LEFT        0x4B00
#define VK_RIGHT       0x4D00
#define VK_DOWN        0x5000

#define VK_F1          0x3B00
#define VK_F2          0x3C00
#define VK_F3          0x3D00
#define VK_F4          0x3E00
#define VK_F5          0x3F00
#define VK_F6          0x4000
#define VK_F7          0x4100
#define VK_F8          0x4200
#define VK_F9          0x4300
#define VK_F10         0x4400
#define VK_F11         0x4500
#define VK_F12         0x4600

#define VK_ASCII_A     0x0041             //0x1E41
#define VK_ASCII_B     0x0042             //0x3042
#define VK_ASCII_C     0x0043             //0x2E43
#define VK_ASCII_D     0x0044             //0x2044
#define VK_ASCII_E     0x0045             //0x1245
#define VK_ASCII_F     0x0046             //0x2146
#define VK_ASCII_G     0x0047             //0x2247
#define VK_ASCII_H     0x0048             //0x2348
#define VK_ASCII_I     0x0049             //0x1749
#define VK_ASCII_J     0x004A             //0x244A
#define VK_ASCII_K     0x004B             //0x254B
#define VK_ASCII_L     0x004C             //0x264C
#define VK_ASCII_M     0x004D             //0x324D
#define VK_ASCII_N     0x004E             //0x314E
#define VK_ASCII_O     0x004F             //0x184F
#define VK_ASCII_P     0x0050             //0x1950
#define VK_ASCII_Q     0x0051             //0x1051
#define VK_ASCII_R     0x0052             //0x1352
#define VK_ASCII_S     0x0053             //0x1F53
#define VK_ASCII_T     0x0054             //0x1454
#define VK_ASCII_U     0x0055             //0x1655
#define VK_ASCII_V     0x0056             //0x2F56
#define VK_ASCII_W     0x0057             //0x1157
#define VK_ASCII_X     0x0058             //0x2D58
#define VK_ASCII_Y     0x0059             //0x1559
#define VK_ASCII_Z     0x005A             //0x2C5A

#define VK_ASCII_a     0x1E61
#define VK_ASCII_b     0x3062
#define VK_ASCII_c     0x2E63
#define VK_ASCII_d     0x2064
#define VK_ASCII_e     0x1265
#define VK_ASCII_f     0x2166
#define VK_ASCII_g     0x2267
#define VK_ASCII_h     0x2368
#define VK_ASCII_i     0x1769
#define VK_ASCII_j     0x246A
#define VK_ASCII_k     0x256B
#define VK_ASCII_l     0x266C
#define VK_ASCII_m     0x326D
#define VK_ASCII_n     0x316E
#define VK_ASCII_o     0x186F
#define VK_ASCII_p     0x1970
#define VK_ASCII_q     0x1071
#define VK_ASCII_r     0x1372
#define VK_ASCII_s     0x1F73
#define VK_ASCII_t     0x1474
#define VK_ASCII_u     0x1675
#define VK_ASCII_v     0x2F76
#define VK_ASCII_w     0x1177
#define VK_ASCII_x     0x2D78
#define VK_ASCII_y     0x1579
#define VK_ASCII_z     0x2C7A

#define VK_ALT_A       0x1E00
#define VK_ALT_B       0x3000
#define VK_ALT_C       0x2E00
#define VK_ALT_D       0x2000
#define VK_ALT_E       0x1200
#define VK_ALT_F       0x2100
#define VK_ALT_G       0x2200
#define VK_ALT_H       0x2300
#define VK_ALT_I       0x1700
#define VK_ALT_J       0x2400
#define VK_ALT_K       0x2500
#define VK_ALT_L       0x2600
#define VK_ALT_M       0x3200
#define VK_ALT_N       0x3100
#define VK_ALT_O       0x1800
#define VK_ALT_P       0x1900
#define VK_ALT_Q       0x1000
#define VK_ALT_R       0x1300
#define VK_ALT_S       0x1F00
#define VK_ALT_T       0x1400
#define VK_ALT_U       0x1600
#define VK_ALT_V       0x2F00
#define VK_ALT_W       0x1100
#define VK_ALT_X       0x2D00
#define VK_ALT_Y       0x1500
#define VK_ALT_Z       0x2C00
#define VK_ALT_1       0x7800
#define VK_ALT_2       0x7900
#define VK_ALT_3       0x7A00
#define VK_ALT_4       0x7B00
#define VK_ALT_5       0x7C00
#define VK_ALT_6       0x7D00
#define VK_ALT_7       0x7E00
#define VK_ALT_8       0x7F00
#define VK_ALT_9       0x8000
#define VK_ALT_0       0x8100

#define VK_CTRL_A      0x0001
#define VK_CTRL_B      0x0002
#define VK_CTRL_C      0x0003
#define VK_CTRL_D      0x0004
#define VK_CTRL_E      0x0005
#define VK_CTRL_F      0x0006
#define VK_CTRL_G      0x0007
#define VK_CTRL_H      0x0008
#define VK_CTRL_I      0x0009
#define VK_CTRL_J      0x000A
#define VK_CTRL_K      0x000B
#define VK_CTRL_L      0x000C
#define VK_CTRL_M      0x000D
#define VK_CTRL_N      0x000E
#define VK_CTRL_O      0x000F
#define VK_CTRL_P      0x0010
#define VK_CTRL_Q      0x0011
#define VK_CTRL_R      0x0012
#define VK_CTRL_S      0x0013
#define VK_CTRL_T      0x0014
#define VK_CTRL_U      0x0015
#define VK_CTRL_V      0x0016
#define VK_CTRL_W      0x0017
#define VK_CTRL_X      0x0018
#define VK_CTRL_Y      0x0019
#define VK_CTRL_Z      0x001A

#define VK_CTRL_BKSPACE 0x7F00
#define VK_CTRL_LEFT    0x7300
#define VK_CTRL_RIGHT   0x7400
#define VK_CTRL_END     0x7500
#define VK_CTRL_PGDN    0x7600
#define VK_CTRL_HOME    0x7700
#define VK_CTRL_PGUP    0x8400
