#include	"microlib.h"

int S4CALL filter_basicfiles(void *info_parm)
{
	FILTER_INFO_BASIC *info;

	info = (FILTER_INFO_BASIC *)info_parm;

	if(memcmp(f4ptr(info->field1), info->find_info1, info->compare_len1))
		return r4ignore;
	if(memcmp(f4ptr(info->field2), info->find_info2, info->compare_len2))
		return r4ignore;

	return r4keep;
	}


int S4CALL filter_cases(void *info_parm)
{
	FILTER_INFO_CASE *info;

	info = (FILTER_INFO_CASE *)info_parm;

	if(info->compare_len1)
		if( memcmp(f4ptr(info->field1), info->find_info1, info->compare_len1))
			return r4ignore;
	if(info->compare_len2)
		if( memcmp(f4ptr(info->field2), info->find_info2, info->compare_len2))
			return r4ignore;
	if(info->compare_len3)
		if( memcmp(f4ptr(info->field3), info->find_info3, info->compare_len3))
			return r4ignore;
	if(info->compare_len4)
		if( memcmp(f4ptr(info->field4), info->find_info4, info->compare_len4))
			return r4ignore;
	if(info->compare_len5)
		if( memcmp(f4ptr(info->field5), info->find_info5, info->compare_len5))
			return r4ignore;
	if(info->compare_len6)
		if( memcmp(f4ptr(info->field6), info->find_info6, info->compare_len6))
			return r4ignore;
	if(info->compare_len7)
		if( memcmp(f4ptr(info->field7), info->find_info7, info->compare_len7))
			return r4ignore;
	if(info->compare_len8)
		if( memcmp(f4ptr(info->field8), info->find_info8, info->compare_len8))
			return r4ignore;
	if(info->compare_len9)
		if( memcmp(f4ptr(info->field9), info->find_info9, info->compare_len9))
			return r4ignore;
	if(info->compare_len10)
		if( memcmp(f4ptr(info->field10), info->find_info10, info->compare_len10))
			return r4ignore;
	if(info->compare_len11)
		if( memcmp(f4ptr(info->field11), info->find_info11, info->compare_len11))
			return r4ignore;

	if(info->compare_from)
		if( a4long(f4ptr(info->field_from)) < info->find_from )
			return r4ignore;

	if(info->compare_to)
		if( a4long(f4ptr(info->field_to)) > info->find_to )
			return r4ignore;

	return r4keep;
	}

int S4CALL filter_doc(void *info_parm)
{
	FILTER_INFO_DOC *info;

	info = (FILTER_INFO_DOC *)info_parm;

	if(info->compare_len1)
		if( memcmp(f4ptr(info->field1), info->find_info1, info->compare_len1))
			return r4ignore;
	if(info->compare_len2)
		if( memcmp(f4ptr(info->field2), info->find_info2, info->compare_len2))
			return r4ignore;
	if(info->compare_len3)
		if( memcmp(f4ptr(info->field3), info->find_info3, info->compare_len3))
			return r4ignore;
	if(info->compare_len4)
		if( memcmp(f4ptr(info->field4), info->find_info4, info->compare_len4))
			return r4ignore;

	if(info->compare_from)
		if( a4long(f4ptr(info->field_from)) < info->find_from )
			return r4ignore;

	if(info->compare_to)
		if( a4long(f4ptr(info->field_to)) > info->find_to )
			return r4ignore;

	return r4keep;
	}
